﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

photoStore = {};
photoStore.modDirectory = g_currentModDirectory;
source(photoStore.modDirectory.."getInputKeys.lua");
photoStore.defaultRotationA = {};
photoStore.defaultRotationB = {};
photoStore.defaultPosition = 0;
photoStore.setRotationA = {0,3.141,0};
photoStore.setRotationB = {0.059,-2.491,0};
photoStore.setPosition = {-0.636,0.765,-6.22};
photoStore.btnDown = false;
photoStore.photoMode = false;
photoStore.masterKey = Input.KEY_lctrl;
photoStore.lightKeys = getInputKeys:getMultipleKeys({"TOGGLE_LIGHTS"});
photoStore.lightKeys = getInputKeys:removeDuplicatesFromEnd(photoStore.lightKeys);
photoStore.lightKeys = getInputKeys:splitKeysFromTable(photoStore.lightKeys[1]);
addModEventListener(photoStore);

function photoStore:update(dt)
	if g_gui:getIsGuiVisible() then	
		if string.upper(tostring(FocusManager.currentGui)) == "SHOPCONFIGSCREEN" then		
			if photoStore.photoMode then				
				setRotation(g_shopConfigScreen.cameraNode, unpack(photoStore.setRotationA))
				setRotation(getParent(g_shopConfigScreen.cameraNode), unpack(photoStore.setRotationB))
			end;
			if Input.isKeyPressed(photoStore.masterKey) then
				local x,y,z = getTranslation(g_shopConfigScreen.cameraNode);
				if #photoStore.defaultRotationA < 1 then
					photoStore.defaultPosition = {x,y,z};
					photoStore.defaultRotationA = {getRotation(g_shopConfigScreen.cameraNode)};
					photoStore.defaultRotationB = {getRotation(getParent(g_shopConfigScreen.cameraNode))};
					photoStore.rootNode = g_shopConfigScreen.workshopNode;
					photoStore.rootNode = getChildAt(photoStore.rootNode,1);
					photoStore.rootNode = getChildAt(photoStore.rootNode,5);
				end;
				if Input.isKeyPressed(Input.KEY_KP_8) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x,y+0.01,z);
				elseif Input.isKeyPressed(Input.KEY_KP_2) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x,y-0.01,z);
				elseif Input.isKeyPressed(Input.KEY_KP_4) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x+0.01,y,z);
				elseif Input.isKeyPressed(Input.KEY_KP_6) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x-0.01,y,z);
				elseif Input.isKeyPressed(Input.KEY_KP_7) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x,y,z-0.01);
				elseif Input.isKeyPressed(Input.KEY_KP_9) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, x,y,z+0.01);
				elseif Input.isKeyPressed(Input.KEY_KP_5) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, unpack(photoStore.defaultPosition));
					setRotation(g_shopConfigScreen.cameraNode, unpack(photoStore.defaultRotationA));
					setRotation(getParent(g_shopConfigScreen.cameraNode), unpack(photoStore.defaultRotationB));
				elseif Input.isKeyPressed(Input.KEY_KP_enter) and not photoStore.btnDown then
					photoStore.btnDown = true;
					setTranslation(g_shopConfigScreen.cameraNode, unpack(photoStore.setPosition));
					setRotation(g_shopConfigScreen.cameraNode, unpack(photoStore.setRotationA));
					setRotation(getParent(g_shopConfigScreen.cameraNode), unpack(photoStore.setRotationB));
					photoStore.photoMode = not photoStore.photoMode;
				end;
			elseif Input.isKeyPressed(Input[photoStore.lightKeys[1]]) and not photoStore.btnDown then
				photoStore.btnDown = true;			
				for _, v in pairs (g_shopConfigScreen.previewVehicles) do
					if v.spec_lights ~= nil then
						v:setNextLightsState();
					end;
				end;
			end;
		else			
			if photoStore.photoMode then photoStore.photoMode = false; end;
		end;
	end;
	if photoStore.btnDown then
		if (not Input.isKeyPressed(Input.KEY_KP_8) and
		not Input.isKeyPressed(Input.KEY_KP_2) and
		not Input.isKeyPressed(Input.KEY_KP_4) and
		not Input.isKeyPressed(Input.KEY_KP_6) and
		not Input.isKeyPressed(Input.KEY_KP_7) and
		not Input.isKeyPressed(Input.KEY_KP_9) and
		not Input.isKeyPressed(Input.KEY_KP_5) and
		not Input.isKeyPressed(Input.KEY_KP_enter) and
		not Input.isKeyPressed(Input[photoStore.lightKeys[1]])) then
			photoStore.btnDown = false;
		end;
	end;
end;

function GuiElement:draw()
	if string.upper(tostring(FocusManager.currentGui)) ~= "SHOPCONFIGSCREEN" or Input.isKeyPressed(Input.KEY_ralt) then	
		if self.newLayer then
			new2DLayer();
		end;
		self:raiseCallback("onDrawCallback", self);
		if self.hasFrame then
			for _, frameOverlay in pairs(self.frameOverlays) do
				frameOverlay:render();
			end;
		end;
		if self.debugEnabled or g_uiDebugEnabled then
			local xPixel = 1 / g_screenWidth;
			local yPixel = 1 / g_screenHeight;
			setOverlayColor(GuiElement.debugOverlay, 1, 0, 0, 1);
			renderOverlay(GuiElement.debugOverlay, self.absPosition[1] - xPixel, self.absPosition[2] - yPixel, self.size[1] + 2 * xPixel, yPixel);
			renderOverlay(GuiElement.debugOverlay, self.absPosition[1] - xPixel, self.absPosition[2] + self.size[2], self.size[1] + 2 * xPixel, yPixel);
			renderOverlay(GuiElement.debugOverlay, self.absPosition[1] - xPixel, self.absPosition[2], xPixel, self.size[2]);
			renderOverlay(GuiElement.debugOverlay, self.absPosition[1] + self.size[1], self.absPosition[2], xPixel, self.size[2]);
		end;
		for _,v in ipairs(self.elements) do
			if v:getIsVisibleNonRec() then	
				v:draw();
			end;
		end;
	end;
end;

function InputGlyphElement:draw()
	if string.upper(tostring(FocusManager.currentGui)) ~= "SHOPCONFIGSCREEN" or Input.isKeyPressed(Input.KEY_ralt) then	
		if #self.actionNames == 0 or not self.overlay.visible then
			return;
		end;
		local posX, posY = self:getPosition();
		if next(self.buttonOverlays) then
			for _, actionName in ipairs(self.actionNames) do
				posX = self:drawControllerButtons(self.buttonOverlays[actionName], posX, posY);
			end;
		elseif next(self.keyNames) then
			for _, actionName in ipairs(self.actionNames) do
				posX = self:drawKeyboardKeys(self.keyNames[actionName], posX, posY);
			end;
		end;
		if self.actionText ~= nil then
			self:drawActionText(posX, posY);
		end;
	end;
end;

function I3DManager:loadSharedI3DFile(filename, baseDir, callOnCreate, addToPhysics, verbose, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments)
    callOnCreate = Utils.getNoNil(callOnCreate, false);
    addToPhysics = Utils.getNoNil(addToPhysics, false);
	if string.find(string.lower(filename), "shop") then
		filename = photoStore.modDirectory.."pinkStore.i3d";
	end;
    local filename = Utils.getFilename(filename, baseDir);
    local sharedI3D = self.sharedI3DFiles[filename];
    -- always print all loading texts
    verbose = true;
    if asyncCallbackFunction ~= nil then
        if sharedI3D == nil then
            local callbacks = self.sharedI3DFilesPendingCallbacks[filename];
            if callbacks == nil then
                self.sharedI3DFilesPendingCallbacks[filename] = {};
                table.insert(self.sharedI3DFilesPendingCallbacks[filename], {callOnCreate, addToPhysics, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments});
                streamI3DFile(filename, "loadSharedI3DFileFinished", self, {filename}, false, false, verbose);
            else
                table.insert(callbacks, {callOnCreate, addToPhysics, asyncCallbackFunction, asyncCallbackObject, asyncCallbackArguments});
            end;
        else
            local id = 0;
            if sharedI3D.nodeId == 0 then
                print("Error: failed to load i3d file '"..filename.."'");
            else
                id = clone(sharedI3D.nodeId, false, callOnCreate, addToPhysics);
            end;
            sharedI3D.refCount = sharedI3D.refCount+1;
            asyncCallbackFunction(asyncCallbackObject, id, asyncCallbackArguments);
        end;
    else
        if sharedI3D == nil then	
			local nodeId = loadI3DFile(filename, false, false, verbose);
            sharedI3D = {nodeId=nodeId, refCount=0};
            self.sharedI3DFiles[filename] = sharedI3D;
        end;
        local id = 0;
        if sharedI3D.nodeId == 0 then
            print("Error: failed to load i3d file '"..filename.."'");
        else
            id = clone(sharedI3D.nodeId, false, callOnCreate, addToPhysics);
        end;
        sharedI3D.refCount = sharedI3D.refCount + 1;
        return id;
    end;
end;

--[[function photoStore:draw(dt)
	if Input.isKeyPressed(Input.KEY_ralt) then		
		local uiScale = g_gameSettings:getValue("uiScale");
		local textSize = 0.02*uiScale;
		local textStringA = "RotationA : "..tostring(unpack(photoStore.defaultRotationA));
		local textStringB = "RotationB : "..tostring(unpack(photoStore.defaultRotationB));
		local textStringP = "Postion : "..tostring(unpack(photoStore.defaultPosition));
		--print(getRotation(g_shopConfigScreen.cameraNode));
		--print(getRotation(getParent(g_shopConfigScreen.cameraNode)));
		--print(getTranslation(g_shopConfigScreen.cameraNode));
		setTextBold(false);
		setTextAlignment(RenderText.ALIGN_RIGHT);
		-----------------------Start Shadow-------------------------------------------
		local offset = textSize * HUDTextDisplay.SHADOW_OFFSET_FACTOR;
		setTextColor(0,0,0,1);
		renderText(0.086 + offset, 0.975 - offset, textSize, textStringP);
		renderText(0.086 + offset, (0.975-(textSize+(textSize/10))) - offset, textSize, textStringA);
		renderText(0.086 + offset, (0.975-(textSize+(textSize/10))*2) - offset, textSize, textStringB);
		------------------------------------------------------------------------------
		setTextColor(0,0.25,1,1);
		renderText(0.086, 0.975, textSize, textStringP);
		renderText(0.086, (0.975-(textSize+(textSize/10))), textSize, textStringA);
		renderText(0.086, (0.975-(textSize+(textSize/10))*2), textSize, textStringB);
	end;
end;]]